// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package org.andromda.samples.animalquiz.decisiontree;

import java.util.Collection;
import java.util.Set;
import org.andromda.samples.animalquiz.Search;
import org.andromda.spring.PaginationResult;

/**
 *
 * @see DecisionItem
 */
public interface DecisionItemDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link DecisionItem}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes entities must be transformed into objects of type
     * {@link VODecisionItem}.
     */
    public static final int TRANSFORM_VODECISIONITEM = 1;

    /**
     * Copies the fields of the specified entity to the target value object. This method is similar to
     * toVODecisionItem(), but it does not handle any attributes in the target
     * value object that are "read-only" (as those do not have setter methods exposed).
     * @param source
     * @param target
     */
    public void toVODecisionItem(
        DecisionItem source,
        VODecisionItem target);

    /**
     * Converts this DAO's entity to an object of type {@link VODecisionItem}.
     * @param entity
     * @return VODecisionItem
     */
    public VODecisionItem toVODecisionItem(DecisionItem entity);

    /**
     * Converts this DAO's entity to a Collection of instances of type {@link VODecisionItem}.
     * @param entities
     */
    public Collection<VODecisionItem> toVODecisionItemCollection(Collection<?> entities);

    /**
     * Converts this DAO's entity to an array of instances of type {@link VODecisionItem}.
     * @param entities
     * @return VODecisionItem[]
     */
    public VODecisionItem[] toVODecisionItemArray(Collection<?> entities);

    /**
     * Copies the fields of {@link VODecisionItem} to the specified entity.
     * @param source
     * @param target
     * @param copyIfNull If FALSE, the value object's field will not be copied to the entity if the value is NULL. If TRUE,
     * it will be copied regardless of its value.
     */
    public void vODecisionItemToEntity(
        VODecisionItem source,
        DecisionItem target,
        boolean copyIfNull);

    /**
     * Converts an instance of type {@link VODecisionItem} to this DAO's entity.
     * @param vODecisionItem
     * @return DecisionItem
     */
    public DecisionItem vODecisionItemToEntity(VODecisionItem vODecisionItem);

    /**
     * Converts a Collection of instances of type {@link VODecisionItem} to this
     * DAO's entity.
     * @param instances
     */
    public void vODecisionItemToEntityCollection(Collection<?> instances);

    /**
     * Gets an instance of DecisionItem from the persistent store.
     * @param id
     * @return DecisionItem
     */
    public DecisionItem get(Long id);

    /**
     * <p>
     * Does the same thing as {@link #get(Long)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Long id);

    /**
     * Loads an instance of DecisionItem from the persistent store.
     * @param id
     * @return DecisionItem
     */
    public DecisionItem load(Long id);

    /**
     * <p>
     * Does the same thing as {@link #load(Long)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Long id);

    /**
     * Loads all entities of type {@link DecisionItem}.
     *
     * @return the loaded entities.
     */
    public Collection<DecisionItem> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Updates the <code>decisionItem</code> instance in the persistent store.
     * @param decisionItem
     */
    public void update(DecisionItem decisionItem);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<DecisionItem> entities);

    /**
     * Removes the instance of DecisionItem from the persistent store.
     * @param decisionItem
     */
    public void remove(DecisionItem decisionItem);

    /**
     * Removes the instance of DecisionItem having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Long id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<DecisionItem> entities);

    /**
     * <p>
     * Returns the root of the decision tree.
     * </p>
     * @return DecisionItem
     * @throws DecisionException
     */
    public DecisionItem findRoot()
        throws DecisionException;

    /**
     * <p>
     * Does the same thing as {@link #findRoot()} with an
     * additional argument called <code>queryString</code>. This <code>queryString</code>
     * argument allows you to override the query string defined in {@link #findRoot()}.
     * </p>
     * @param queryString
     * @return DecisionItem
     * @throws DecisionException
     */
    public DecisionItem findRoot(String queryString)
        throws DecisionException;

    /**
     * <p>
     * Does the same thing as {@link #findRoot()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then finder results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * @param transform
     * @return Object
     * @throws DecisionException
     * </p>
     */
    public Object findRoot(int transform)
        throws DecisionException;

    /**
     * <p>
     * Does the same thing as {@link #findRoot(int)} with an
     * additional argument called <code>queryString</code>. This <code>queryString</code>
     * argument allows you to override the query string defined in {@link #findRoot(int)}.
     * </p>
     * @param transform
     * @param queryString
     * @return Object
     * @throws DecisionException
     */
    public Object findRoot(int transform, String queryString)
        throws DecisionException;


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<DecisionItem> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>org.andromda.samples.animalquiz.decisiontree.DecisionItemDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     * <p>
     * This method will return instances of these types:
     * <ul>
     *   <li>{@link DecisionItem} - {@link #TRANSFORM_NONE}</li>
     *   <li>{@link VODecisionItem} - {@link #TRANSFORM_VODECISIONITEM}</li>
     * </ul>
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link org.andromda.samples.animalquiz.decisiontree.DecisionItemDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final DecisionItem entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,DecisionItem)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>org.andromda.samples.animalquiz.decisiontree.DecisionItemDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,DecisionItem)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}